module dcl_alloc  ! namelist ɤ߹, դ

  use dcl_defval
  use dcl_arrayval
  use m_stretch

contains

subroutine dcl_alloc_val( stat )

  use dcl_defval
  use dcl_arrayval
  implicit none
  integer,intent(in) :: stat
  integer :: tmp_num1  !  1
  integer :: tmp_num2  !  2

  call val_counter( d2valc, val2d )
  call val_counter( ad2valc, val2ad )
  if(val2d+val2ad==0)then
     tmp_num1=1
  else
     tmp_num1=val2d+val2ad
  end if
  call val_counter( d3valc, val3d )
  call val_counter( ad3valc, val3ad )
  if(val3d+val3ad==0)then
     tmp_num2=1
  else
     tmp_num2=val3d+val3ad
  end if

  allocate(x(nx))
  allocate(y(ny))
  allocate(z(nz))
  allocate(lon(nx))
  allocate(lat(ny))
  allocate(val2(nx,ny,tmp_num1))
  allocate(val3(nx,ny,nz,tmp_num2))

end subroutine

subroutine dcl_pointdef( stat )
!  ʻҿȻ, ʻҴֳֺ֤ɸͤ롼
!  nx, ny Ĵ, lon, lat ˤŬѲǽ.
  use dcl_defval
  use dcl_arrayval
!  use m_stretch
  implicit none
  integer, intent(inout) :: stat
  integer :: i
  real, allocatable :: tmpz(:), tmpdz(:)
  real :: ztop1, ztop2, zsfc

  allocate(tmpz(nz+3))  !  stretch array
  allocate(tmpdz(nz+3))  !  stretch array

  zsfc=0.0
  ztop1=zsfc+dz*real(nz)
  ztop2=ztop1-dz

  x=(/((xmin+dx*(i-1)),i=1,nx)/)
  y=(/((ymin+dy*(i-1)),i=1,ny)/)

  if(layer1/=0.0.or.layer2/=0.0)then
     call stretch( sthopt, 0.0, dzmin, layer1, layer2, ztop2, ztop1,  &
  &                nz+3, tmpz, tmpdz )
     do i=1,nz
        z(i)=tmpz(i+1)
     end do
  else
     z=(/((zmin+dz*(i-1)),i=1,nz)/)
  end if

  lon=(/((lon_min+dlon*(i-1)),i=1,nx)/)
  lat=(/((lat_min+dlat*(i-1)),i=1,ny)/)

  deallocate(tmpz)
  deallocate(tmpdz)

end subroutine

subroutine val_counter( valc, valcount )
  ! CReSS  dump ե˳ǼƤ 3 ѿΤ, ƤӽФ
  ! ɬפΤѿο׻롼
  ! valc  '121000021' ʤɤʸѿ˿ޤƤȤ.
  ! 1 ܤ˿ɾ, Ĥѿɬפ׻.
  ! '0' = ѿȤƥȤʤ, '1' = 1 ʬȤѿ򥫥Ȥ.
  ! ʤߤƱͤΥեޥåȤˤ, 2 ǤǤѲǽ.
  use dcl_defval
  use dcl_arrayval
  implicit none
  character(*), intent(in) :: valc  ! dump Ƥ뤫γǧѿ
  integer, intent(inout) :: valcount  ! ѰդɬפΤѿο
  integer :: i, chan

  valcount=0
  chan=len_trim(valc)
write(*,*) "len=", chan
  do i=1,chan
     select case (valc(i:i))
     case ('0')
        valcount=valcount
     case ('1')
        valcount=valcount+1
     end select
  end do

end subroutine

subroutine dcl_dealloc_val

  use dcl_defval
  use dcl_arrayval
  deallocate(x)
  deallocate(y)
  deallocate(z)
  deallocate(lon)
  deallocate(lat)
  deallocate(val2)
  deallocate(val3)

end subroutine

end module

